import unittest
from geniusweb.actions.PartyId import PartyId
from geniusweb.actions.Offer import Offer
from pyson.ObjectMapper import ObjectMapper
from geniusweb.actions.Action import Action

class OfferTest (unittest.TestCase) :

	def testSerialize(self):
		
		actor=PartyId("myid")
		# HACK currently bid requires all values same type
		bid={'fte':3, 'leasecar':'yes'}
		offer=Offer(actor, bid)
		
		pyson=ObjectMapper()
		print(str(pyson.toJson(offer)))
		self.assertEqual({'Offer': {'actor': {'name': 'myid'}, 'bid': {'fte': 3, 'leasecar': 'yes'}}}, 
						pyson.toJson(offer))
		
	def testDeserialize(self):
		actor=PartyId("myid")
		# HACK currently bid requires all values same type
		bid={'fte':3, 'leasecar':'yes'}
		offer=Offer(actor, bid)
		pyson=ObjectMapper()

		jsonoffer= pyson.toJson(offer)
		self.assertEqual(offer, pyson.parse(jsonoffer, Action))
		